# usr/bin/perl -w
# Area Under ROC is approximated by the Area of a trapezoid 
# Area of a trapezoid = |x1 - x2| * (y1+y2)/2

#column of False-positive rate (x-axis in the ROC) default 1 is the 1st column
my $xcol = $ARGV[0]-1;
#column of True-positive rate (y-axis in the ROC) default 2 is the 2nd column
my $ycol = $ARGV[1]-1;

my $AUC = 0;
my $x2 = 0;
my $y2 = 0;

open (inFile, "<&STDIN");
open (outFile, ">&STDOUT");
while (my $line = <inFile>) {
	next if ($line =~ /^[A-Za-z]/);
	chomp ($line);	
	my @cols = split ("\t", $line);
	my ($x1, $y1) = ($cols[$xcol], $cols[$ycol]);
	$AUC += abs($x2 - $x1) * ($y2 + $y1)/2;
	($x2, $y2) = ($x1, $y1);
}

printf (outFile "%.5f\n", $AUC);
close (inFile);
