#!/usr/bin/perl -w
use warnings;
use strict;

my $num = $ARGV[0];
open(inFile, "<&STDIN") or die ("Can't open the input file : $!");
open(outFile, ">&STDOUT") or die ("Can't open the output file : $!");

while(my $line = <inFile>){
	if($line =~ /^[\-0-9]/){
		chomp($line);
		my ($label, @row) = split(" ",$line);

		my @cols = ();		
		for (my $i=0; $i < $num; $i++) {
			$cols[$i] = 0;
		}
		
		foreach my $col (@row){
			my ($left, $right) = split(":", $col);
			$cols[$left-1] = $right;
		}
			
		printf (outFile join(" ", @cols, $label)."\n");
	}
}

close (inFile) or die ("can't close the input file : $!");
close (outFile) or die ("can't close the output file : $!"); 
