# usr/bin/perl -w
# Compute ROC
use Statistics::ROC;

#column of Probability estimates default 1 is the 1st column
my $pcol = $ARGV[0]-1;
#column of Classes default 2 is the 2nd column. 
my $classcol = $ARGV[1]-1;
#model 'decrease' or 'increase'
my $model = 'decrease';
$model = 'increase' if ($ARGV[2] == 1);


open (inFile, "<&STDIN");
open (outFile, ">&STDOUT");

my @var_grp = ();
my $i=0;
while (my $line = <inFile>) {
	chomp($line);
	my @cols = split (" ", $line); 
	#0 for disease (or signal) not present (prior knowledge)
	#1 for disease (or signal) present (prior knowledge)
	$cols[$classcol] = 0 if ($cols[$classcol] == -1);
	push(@{$var_grp[$i++]}, $cols[$pcol], $cols[$classcol]);	
}

printf (outFile "FPR\tTPR\n");
my @curves = roc($model, 0.95, @var_grp);
foreach my $i (@{$curves[1]}){
	# 1st column contains the False-positive rate (x-axis in the ROC)
	# 2nd column contains the True-positive rate (y-axis in the ROC)
	printf (outFile join("\t", @{$i})."\n");
}

close (inFile);
close (outFile);
