BEGIN {
	OFS="\t";
	TP=0;
	FP=0;
	TN=0;
	FN=0;
} 

{
	#if ($4 > 0 && $2 > $3) TP++; 
	if ($NF > 0 && $1 > 0) TP++
	#if ($4 > 0 && $2 < $3) FN++; 
	if ($NF > 0 && $1 < 0) FN++
	#if ($4 < 0 && $2 > $3) FP++; 
	if ($NF < 0 && $1 > 0) FP++; 
	#if ($4 < 0 && $2 < $3) TN++;
	if ($NF < 0 && $1 < 0) TN++;
} 

END {
	P=TP+FN; 
	N=FP+TN; 
	if (P > 0) SE=TP/P*100; else SE = "NaN";
	if (N > 0) SP=TN/N*100; else SP = "NaN";
	if (N > 0) FPr=100-SP; else FPr = "NaN";
	if (TP > 0 || FP > 0) PPV=TP/(TP+FP)*100; else PPV="NaN";
	if (TN > 0 || FN > 0) NPV=TN/(TN+FN)*100; else NPV="NaN";
	if (P > 0 || N > 0) ACC=(TP+TN)/(P+N)*100; else ACC="NaN";
	if (N > 0 && P > 0) Fm=2*SE*SP/(SE+SP); else Fm="NaN";
	if (N > 0 && P > 0 && (TP+FP) > 0 && (TN+FN) > 0) MCC=(TP*TN-FP*FN)/sqrt(P*N*(TP+FP)*(TN+FN))*100; else MCC="NaN";
	
	if (header == 1) {
		if (type != "") printf "Type    \t";
						printf "TP\tFN\tP\tFP\tTN\tN\t%SE\t%SP\t%FPr\t%PPV\t%NPV\t%ACC\t%Fm\t%MCC";
		if (auc != "") 	printf "\tAUC";
						printf "\n";
	}
	
	if (type != "") printf "%-10s\t", type;
					printf "%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s", \
							TP, FN, P, FP, TN, N, SE, SP, FPr, PPV, NPV, ACC, Fm, MCC;
					#printf "%u\t%u\t%u\t%u\t%u\t%u\t%2.3f\t%2.3f\t%2.3f\t%2.3f\t%2.3f\t%2.3f\t%2.3f\t%2.3f", \
					#		TP, FN, P, FP, TN, N, SE*100, SP*100, FPr*100, PPV*100, NPV*100, ACC*100, Fm*100, MCC*100;
	if (auc != "") 	printf "\t%.5f", auc;
					printf "\n";
	
}
